﻿@model IEnumerable<CarRental.Core.Models.Car>

@{
    ViewData["Title"] = "List";
    Layout = "~/Areas/CarOwner/Views/Shared/_Layout.cshtml";
}
<style>
    .carousel-item {
        height: 280px;
    }

        .carousel-item img {
            height: 280px !important;
        }
</style>

<section class="ftco-section bg-light">
    <div class="container">
        <div class="row">
            <div class="col-md-8">
                <a asp-area="CarOwner" asp-controller="Cars" asp-action="Create" class="btn btn-primary"> Add Car</a>
            </div>
            <div class="col-md-4">
                <select id="sortOrderSelect" class="custom-select w-75 custom-select-lg d-block float-right">
                    <option value="Newest to Lastest">Newest to Lastest</option>
                    <option value="Lastest to Newest">Lastest to Newest</option>
                    <option value="Order By Price">Order By Price</option>
                </select>
            </div>
        </div>
        <div id="modelListContainer">
            <partial name="_CarsListPartial" model="Model" />
        </div>

        <div class="row mt-5">
            <div class="col text-center">
                <div class="block-27" id="paginationContainer" data-total-pages="@ViewBag.TotalPages">
                    <ul>
                        <li><a id="previous-page">&lt;</a></li>
                        <li class="active"><span>1</span></li>
                        <li><a id="next-page">&gt;</a></li>
                    </ul>
                </div>
            </div>
        </div>
    </div>
</section>

<script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
<script>

    window.onload = function () {
        var carElements = document.querySelectorAll("[id^='carStatus']");
        carElements.forEach(function (carElement) {
            var carStatus = carElement.textContent.trim();

            switch (carStatus) {
                case "Available":
                    carElement.style.color = "green";
                    break;
                case "Booked":
                    carElement.style.color = "blue";
                    break;
                case "Stopped":
                    carElement.style.color = "red";
                    break;
                default:
                    carElement.style.color = "black";
            }
        });
    };

    $(document).ready(function () {
        // Function to update cars based on sort order and page number
        function updateCars(sortOrder, pageNumber) {
            $.ajax({
                url: '/CarOwner/Cars/SortAndPaginateCars',
                type: 'GET',
                data: { sortOrder: sortOrder, pageNumber: pageNumber },

                success: function (result) {
                    $('#modelListContainer').empty();
                    $('#modelListContainer').html(result);
                    console.log(result);

                    updatePagination(pageNumber);
                }
            });
        }

        // display sorted car default each time reloading page

    @* var initialSortOrder = $('#sortOrderSelect').val();

            // Update cars with initial sort order (page number is 1)
            updateCars(initialSortOrder, 1);*@

            // Function to update pagination links
            function updatePagination(currentPage) {
                var totalPages = parseInt($('#paginationContainer').attr('data-total-pages'));
                var paginationContainer = $('#paginationContainer');
                paginationContainer.empty();

                if (currentPage > 1) {
                    paginationContainer.prepend('<a id="previous-page">&lt;</a>');
                }

                for (var i = 1; i <= totalPages; i++) {
                    if (i === currentPage) {
                        paginationContainer.append('<span class="active">' + i + '</span>');
                    } else {
                        paginationContainer.append('<a data-page="' + i + '">' + i + '</a>');
                    }
                }

                if (currentPage < totalPages) {
                    paginationContainer.append('<a id="next-page">&gt;</a>');
                }
            }

        // Event handler for sort order change
        $(document).on('change', '#sortOrderSelect', function () {
            var sortOrder = $(this).val();
            var pageNumber = 1;

            updateCars(sortOrder, pageNumber);
        });

        // Event handler for pagination link click
        $(document).on('click', '#paginationContainer a', function () {
            var sortOrder = $('#sortOrderSelect').val();
            var pageNumber = $(this).data('page');

            updateCars(sortOrder, pageNumber);
        });

        // Event handler for previous page button click
        $(document).on('click', '#previous-page', function () {
            var sortOrder = $('#sortOrderSelect').val();
            var currentPage = parseInt($('#paginationContainer .active').text());
            var pageNumber = currentPage - 1;

            updateCars(sortOrder, pageNumber);
        });

        // Event handler for next page button click
        $(document).on('click', '#next-page', function () {
            var sortOrder = $('#sortOrderSelect').val();
            var currentPage = parseInt($('#paginationContainer .active').text());
            var pageNumber = currentPage + 1;

            updateCars(sortOrder, pageNumber);
        });
    });
</script>
@section Css {
    <style>
        .checked {
            color: orange;
        }
    </style>
}